<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html"></xsl:output>


    <!--building main html output -->
    <xsl:template match="root">
        <html>
            <head>
                <title>Configuration</title>
                <link rel="stylesheet" type="text/css" href="_statics/doc.css"/>
                <script type="text/javascript" src="_statics/doc.js"></script>
            </head>
            <body>
                <xsl:apply-templates/>
            </body>
        </html>
    </xsl:template>


    <!-- replace <cr> with <br> "very useful for lines prperties :-)"-->
    <xsl:template name="raw_text">
        <xsl:param name="text" />
        <xsl:choose>
            <xsl:when test="contains($text,'&#xA;')">
                <xsl:call-template name="raw_text">
                    <xsl:with-param name="text" select="concat(substring-before($text,'&#xA;'), '&lt;br&gt;',substring-after($text,'&#xA;'))" />
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of disable-output-escaping="yes" select="$text" />
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>


    <!--file template -->
    <xsl:template name="filename">
        <span class="file">
            <xsl:variable name="filetoinsert"
                          select="document(concat(@path,'/',@filename))"/>
                        
            <xsl:apply-templates  select="$filetoinsert/*" />
        </span>
    </xsl:template>


    <!--directory template -->
    <xsl:template name="directory">
        <!--add something here ?-->
    </xsl:template>


    <!-- main template here -->
    <xsl:template match="*" name="root">
        <ul>
            <!--<li>-->
                <span class="node">
                    <xsl:attribute name="onClick">
                    show_hideNode('<xsl:value-of select="generate-id(.)"/>');
                    </xsl:attribute>
                    
                    <xsl:if test="node()">
                        <img src="_statics/folderclosed.gif">
                            <xsl:attribute name="id">Img_id_<xsl:value-of select="generate-id(.)"/></xsl:attribute>
                        </img>  
                            <xsl:value-of select="name()" /> :
                                <xsl:call-template name="raw_text">
                                    <xsl:with-param name="text" select="/text" />
                                </xsl:call-template>
                    </xsl:if>
                </span>
    
                <span>
                        <ul>
                            <xsl:for-each select="@*">
                                <li>
                                    <span class="attribute_name" ><xsl:value-of select="name()" /> </span> : <span class="attribute_value"><xsl:value-of select="." /></span>
                                </li>
                            </xsl:for-each>
                        </ul>
                </span>
    
                <!-- details style dispay : none -->
                <span class="details">
                    <xsl:attribute name="id">
                        <xsl:value-of select="generate-id(.)"/>
                    </xsl:attribute>
                    <xsl:apply-templates/>
                </span>
                
                <!--directory case-->
                <xsl:if test="name() = 'directory'">
                    <xsl:call-template name="directory" />
                </xsl:if>

                <!--file case-->
                <xsl:if test="name() = 'filename'">
                    <xsl:call-template name="filename" />
                </xsl:if>

            <!--</li>-->
        </ul>

    </xsl:template>


</xsl:stylesheet>
